本文主要是介绍Codeforces 10 D. LCIS,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!
This problem differs from one which was on the online contest.
The sequence a1, a2, ..., an is called increasing, if ai < ai + 1 for i < n.
The sequence s1, s2, ..., sk is called the subsequence of the sequence a1, a2, ..., an, if there exist such a set of indexes 1 ≤ i1 < i2 < ... < ik ≤ n that aij = sj. In other words, the sequence s can be derived from the sequence a by crossing out some elements.
You are given two sequences of integer numbers. You are to find their longest common increasing subsequence, i.e. an increasing sequence of maximum length that is the subsequence of both sequences.
The first line contains an integer n (1 ≤ n ≤ 500) — the length of the first sequence. The second line contains n space-separated integers from the range [0, 109] — elements of the first sequence. The third line contains an integer m (1 ≤ m ≤ 500) — the length of the second sequence. The fourth line contains m space-separated integers from the range [0, 109] — elements of the second sequence.
In the first line output k — the length of the longest common increasing subsequence. In the second line output the subsequence itself. Separate the elements with a space. If there are several solutions, output any.
7 2 3 1 6 5 4 6 4 1 3 5 6
3 3 5 6
5 1 2 0 2 1 3 1 0 1
2 0 1
我自己一开始写的 多用了一维空间
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;ll ans; ll cnt = 0;
const int maxn = 505;
ll a[maxn], b[maxn], dp[maxn][maxn];
ll maxx;
int main(){int an, bn;cin>>an;for (int i=0; i<an; i++){cin>>a[i];}cin>>bn;for (int i=0; i<bn; i++){cin>>b[i];}memset(dp, 0, sizeof (dp));for (int i=0; i<bn; i++){if (a[0] == b[i]){dp[0][i] = 1;}}for (int i=1; i<an; i++){maxx = 0;for (int j=0; j<bn; j++){if (a[i] == b[j]) dp[i][j] = maxx+1;else dp[i][j] = dp[i-1][j];//没用的步骤if (b[j] < a[i]) maxx = max(maxx, dp[i][j]);}}maxx = 0;for (int i=0; i<bn; i++){maxx = max(maxx, dp[an-1][i]);}cout<<maxx<<endl;return 0;
}
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
/*
如何输出路径
dp[i] 为以 bi结尾的最长公共上升字串长度
而且越往后出现的a[i] == b[j], dp[i]肯定越大 所以更新不用判断
所以只要在dp[i]更新时记录是从哪来的 就可以了
*/
ll cnt = 0;
const int maxn = 505;
ll a[maxn], b[maxn], dp[maxn];
int pre[maxn], ans[maxn]; int pos, maxx;
int main(){int an, bn;cin>>an;for (int i=1; i<=an; i++){cin>>a[i];}cin>>bn;for (int i=1; i<=bn; i++){cin>>b[i];}memset(dp, 0, sizeof (dp));memset(pre, -1, sizeof(pre));for (int i=1; i<=an; i++){ pos = 0;for (int j=1; j<=bn; j++){///从0开始处理边界麻烦 所以本题从1开始if (a[i] == b[j]) dp[j] = dp[pos] +1, pre[j] = pos;if (b[j] < a[i] && dp[pos] < dp[j])pos = j;}}maxx = -1;for (int i=1; i<=bn; i++){if (maxx < dp[i]) {maxx = dp[i];pos = i;}}for (int i=maxx; i; i--){ans[i] = b[pos];pos = pre[pos];}cout<<maxx<<endl;for (int i=1; i<=maxx; i++){printf("%d ", ans[i]);}puts("");return 0;
}
这篇关于Codeforces 10 D. LCIS的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!